PROGRAM_NAME='AddressBook'
/////////////////////////////////////////////////////////////
//                                                         //
//                  NetLinx System                         //
//             Project: Bose Control Space Solution        //
//                                                         //
/////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////
//                  Define Device                          //
/////////////////////////////////////////////////////////////
DEFINE_DEVICE

/////////////////////////////////////////////////////////////
//                  Debug	                           //
/////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////
//                  Constants                              //
/////////////////////////////////////////////////////////////
DEFINE_CONSTANT

PB_VOIP	=	1
PB_PSTN = 	2

char PSTN_ADDRESS_BOOK[] = 'PSTN_Example_Phone_Book.csv'
char VOIP_ADDRESS_BOOK[] = 'VoIP_Example_Phone_Book.csv'

/////////////////////////////////////////////////////////////
//                  Structures                             //
/////////////////////////////////////////////////////////////
DEFINE_TYPE


/////////////////////////////////////////////////////////////
//                  Variables                              //
/////////////////////////////////////////////////////////////
DEFINE_VARIABLE

// Phone books update every hour..
long tlAddressBookTimes[] = { 1800000 , 1800000 }

integer btnAbEntries[] = { 51 , 52 , 53 , 54 , 55 , 56 }
integer btnAbArrows[] =  { 61 , 62 }

/////////////////////////////////////////////////////////////
//                  Functions/Calls                        //
/////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////
//                  Functions/Calls                        //
/////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////
// fnReadAddressBook 
define_function fnReadAddressBook (integer pbType , char phoneBook[64] ) {
    sInteger fileHandler,readResult
    integer pbIdx
    char fileText[1024], phoneBookEntry[64]
    fileHandler = FILE_OPEN(phoneBook, 1 )
    
    if (fileHandler) {
	readResult = FILE_READ (fileHandler, fileText, 1024)
	
	if(readResult) {
	
	    while(find_string(fileText,"$0d,$0a",1)) {
		// Increment pb Index
		pbIdx = pbIdx + 1
		
		phoneBookEntry = remove_string(fileText,"$0d,$0a",1)
		
		if(find_string(phoneBookEntry,',',1)) {
		    fnAddPhoneBookEntrie(pbType, pbIdx , phoneBookEntry)
		}
	    }
	    
	    // This checks to see if the file last line has a entrie but no <CR>
	    if(length_string(fileText) && find_String(fileText,',',1)) {
		// Increment pb Index
		pbIdx = pbIdx + 1
	    
		fnAddPhoneBookEntrie(pbType, pbIdx , fileText)
	    }
	}
	else {
	    fndebug('AddressBook', "'Unable to read file : ', itoa(readResult)")
	}
    }
    else {
	fndebug('AddressBook', "'Unable to open file : ', itoa(fileHandler)")
    }

}

/////////////////////////////////////////////////////////////
// fnAddPhoneBookEntrie 
define_function fnAddPhoneBookEntrie(integer pbType , integer idx , char pbEntrie[] ) {

    char name[MAX_PB_NAME_LEN],number[MAX_PB_NUM_LEN]
    
    name = remove_String(pbEntrie,',',1)
    number = pbEntrie
    
    // remove trailing comma from name..
    set_length_string(name,length_string(name) - 1)
    
    // remove trailing CR from number..
    set_length_string(number,length_string(number) - 2)
    
    // Add Entrie to the Phonebook..
    switch(pbType) {
	case PB_VOIP: {
	    VoIP_pb.entrie[idx].name = name
	    VoIP_pb.entrie[idx].number = number
	    VoIP_pb.totalEntries = idx
	}
	case PB_PSTN: {
	    PSTN_pb.entrie[idx].name = name
	    PSTN_pb.entrie[idx].number = number
	    PSTN_pb.totalEntries = idx
	}
    }

}

/////////////////////////////////////////////////////////////
//                  StartUp                                //
/////////////////////////////////////////////////////////////
DEFINE_START

/////////////////////////////////////////////////////////////
//                  Event's                                //
/////////////////////////////////////////////////////////////
DEFINE_EVENT

/////////////////////////////////////////////////////////////
// Data Events..
// Program startup events on Virtual device comming online..
data_event[vdvSystem]
{
    online: {
	// Read our address book..
	fnReadAddressBook (PB_VOIP, VOIP_ADDRESS_BOOK)
	fnReadAddressBook (PB_PSTN, PSTN_ADDRESS_BOOK)
	timeline_create(cTL_PB_REFRESH, tlAddressBookTimes , length_array(tlAddressBookTimes) , TIMELINE_RELATIVE , TIMELINE_REPEAT)
    }
    command: {
	if(find_string(data.text,'UPDATE-ADDR',1)) {
	    fnReadAddressBook (PB_VOIP, VOIP_ADDRESS_BOOK)
	    fnReadAddressBook (PB_PSTN, PSTN_ADDRESS_BOOK)
	}
    }
}

/////////////////////////////////////////////////////////////
// TimeLine Events..
// Refresh address books..
timeline_event[cTL_PB_REFRESH]
{
    switch(timeline.sequence){
	case 1: {
	    fnReadAddressBook (PB_VOIP, VOIP_ADDRESS_BOOK)
	}
	case 2: {
	    fnReadAddressBook (PB_PSTN, PSTN_ADDRESS_BOOK)
	}	
    }
}

/////////////////////////////////////////////////////////////
//                  MainLine                               //
/////////////////////////////////////////////////////////////
DEFINE_PROGRAM

/////////////////////////////////////////////////////////////
//                  The End                                //
/////////////////////////////////////////////////////////////

