PROGRAM_NAME='CombineViaCrr'
/////////////////////////////////////////////////////////////
//                                                         //
//                  NetLinx System                         //
//             Project: Bose Control Space Solution        //
//                                                         //
/////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////
//                  Define Device                          //
/////////////////////////////////////////////////////////////
DEFINE_DEVICE

/////////////////////////////////////////////////////////////
//                  Debug	                           //
/////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////
//                  Constants                              //
/////////////////////////////////////////////////////////////
DEFINE_CONSTANT


/////////////////////////////////////////////////////////////
//                  Structures                             //
/////////////////////////////////////////////////////////////
DEFINE_TYPE


/////////////////////////////////////////////////////////////
//                  Variables                              //
/////////////////////////////////////////////////////////////
DEFINE_VARIABLE

// Combine Buttons
integer btnCombineCRR[] = { 11 , 12} 

// Combine VT..
integer vtCrrRoomBlanks[] = { 13 , 14 }

/////////////////////////////////////////////////////////////
//                  Functions/Calls                        //
/////////////////////////////////////////////////////////////

// Tells us if rooms are chained together..
define_function integer fnCanUncombineCrr (integer btn) {
    
    // Update the Combine Masking..
    switch(GET_SYSTEM_NUMBER()) {
	case 1: {
	    if(btn = 1 && !CrrCombineState[2]) {
		return 1;
	    }
	    else if(btn = 2 ){
		return 1
	    }
	    else {
		return 0;
	    }
	}
	case 2: {
	    return 1;
	}
	case 3: {
	    if(btn = 2 && !CrrCombineState[1]) {
		return 1;
	    }
	    else if(btn = 1 ){
		return 1
	    }
	    else {
		return 0;
	    }
	}
    }
}
/////////////////////////////////////////////////////////////
// fnCombineRoomsUiUpdate () :: Update Combine UI..
define_function fnCrrCombineRoomsUiUpdate () {
    
    // Go to correct page for combine state..
    if(fnRoomsCombined()) {
    
	if(CrrCombineState[1] && CrrCombineState[2]) {
	    send_command dvTP,"'PAGE-Combined3'"
	}
	else {
	    switch(GET_SYSTEM_NUMBER()) {
		case 1: {
		    if(CrrCombineState[1] || CrrCombineState[1]) {
			send_command dvTP,"'PAGE-Combined1'"
		    }
		}
		case 2: {
		    if(CrrCombineState[1] ||CrrCombineState[2]) {
			send_command dvTP,"'PAGE-Combined1'"
		    }
		    else {
			send_command dvTP,"'PAGE-Combined2'"
		    }
		}
		case 3: {
		    if(CrrCombineState[2] || CrrCombineState[2]) {
			send_command dvTP,"'PAGE-Combined2'"
		    }
		}
	    }
	}
	send_command dvTP,"'PPON-Combine'"
    }
    else {
	send_command dvTP,"'PAGE-Single'"
	send_command dvTP,"'PPON-Combine'"
    }
    
    // Turn on combine state buttons..
    
    if(CrrCombineState[1]) {
	on[dvTpCombine,btnCombineCRR[1]]
    }
    else {
	off[dvTpCombine,btnCombineCRR[1]]
    }
    
    if(CrrCombineState[2]) {
	on[dvTpCombine,btnCombineCRR[2]]
    }
    else {
	off[dvTpCombine,btnCombineCRR[2]]
    }

    // Update the Combine Masking..
    switch(GET_SYSTEM_NUMBER()) {
	case 1: {
	    send_command dvTpCombine,"'^SHO-',itoa(vtCrrRoomBlanks[1]),',0'"
	    
	    if(CrrCombineState[1]) {
		send_command dvTpCombine,"'^SHO-',itoa(vtCrrRoomBlanks[2]),',0'"
	    }
	    else {
		send_command dvTpCombine,"'^SHO-',itoa(vtCrrRoomBlanks[2]),',1'"
	    }
	    
	}
	case 2: {
	    send_command dvTpCombine,"'^SHO-',itoa(vtCrrRoomBlanks[1]),',0'"
	    send_command dvTpCombine,"'^SHO-',itoa(vtCrrRoomBlanks[2]),',0'"
	}
	case 3: {
	    send_command dvTpCombine,"'^SHO-',itoa(vtCrrRoomBlanks[2]),',0'"
	    
	    if(CrrCombineState[2]) {
		send_command dvTpCombine,"'^SHO-',itoa(vtCrrRoomBlanks[1]),',0'"
	    }
	    else {
		send_command dvTpCombine,"'^SHO-',itoa(vtCrrRoomBlanks[1]),',1'"
	    }
	}
    }
    fnSetRoomName ()
}

define_function fnCombineCrrCmd () {
    integer offset;
    
    offset = 2;
    
    if(CrrCombineState[1] && CrrCombineState[2]) {
	// Combine Rooms 1,2 and 3..
	do_push(vdvRoomCombine,4 + offset)
    }
    else if(CrrCombineState[1]) {
	// Combine Rooms 1 and 2..
	do_push(vdvRoomCombine,1 + offset) 
    }
    else if(CrrCombineState[2]) {
	// Combine Rooms 2 and 3..
	do_push(vdvRoomCombine,2 + offset)  
    }
    else {
	// Split Rooms..
	do_push(vdvRoomCombine,3 + offset) 
    }
    
    fnCrrCombineRoomsUiUpdate ()
}

/////////////////////////////////////////////////////////////
//                  StartUp                                //
/////////////////////////////////////////////////////////////
DEFINE_START

/////////////////////////////////////////////////////////////
//                  Event's                                //
/////////////////////////////////////////////////////////////
DEFINE_EVENT

/////////////////////////////////////////////////////////////
// Channel Events..
channel_event[vdvSystem,1] {
    on: { 
	// Start Module..
	on[vdvParameterSet,1]
	on[vdvRoomCombine,1]
    }
}

/////////////////////////////////////////////////////////////
// Button Events..
button_Event[dvTpCombine,btnCombineCRR] {
    push: {

	integer btn;
	
	btn = get_last(btnCombineCRR)
	
	if(CrrCombineState[btn] = 0) {
	    // Update Combine Status..
	    CrrCombineState[btn] = 1
	    
	    //Call Combine Command
	    fnCombineCrrCmd()
	}	
	// Uncombine Rooms..
	else if(CrrCombineState[btn] = 1 && fnCanUncombineCrr(btn)) {
	    // Update Combine Status..
	    CrrCombineState[btn] = 0
	    
	    // Set room contrling back to default room..
	    roomControling = thisSys;
	    
	    //Call Combine Command
	    fnCombineCrrCmd()
	}
	else {
	    // Rooms need to be uncombined before they can be combined..
	}
    
	fnRoomSelect()
    }	
}

/////////////////////////////////////////////////////////////
// TimeLine Events..

/////////////////////////////////////////////////////////////
//                  MainLine                               //
/////////////////////////////////////////////////////////////
DEFINE_PROGRAM

/////////////////////////////////////////////////////////////
//                  The End                                //
/////////////////////////////////////////////////////////////

