PROGRAM_NAME='CombineViaPresets'
/////////////////////////////////////////////////////////////
//                                                         //
//                  NetLinx System                         //
//             Project: Bose Control Space Solution        //
//                                                         //
/////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////
//                  Define Device                          //
/////////////////////////////////////////////////////////////
DEFINE_DEVICE

/////////////////////////////////////////////////////////////
//                  Debug	                           //
/////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////
//                  Constants                              //
/////////////////////////////////////////////////////////////
DEFINE_CONSTANT


/////////////////////////////////////////////////////////////
//                  Structures                             //
/////////////////////////////////////////////////////////////
DEFINE_TYPE


/////////////////////////////////////////////////////////////
//                  Variables                              //
/////////////////////////////////////////////////////////////
DEFINE_VARIABLE

// Combine Buttons
integer btnCombinePresets[] = { 21 , 22 }


// Combine VT..
integer vtRoomBlanks[]	= { 11 , 12 }

/////////////////////////////////////////////////////////////
//                  Functions/Calls                        //
/////////////////////////////////////////////////////////////

// Tells us if rooms are chained together..
define_function integer fnCanUncombinePresets (integer btn) {
    
    // Update the Combine Masking..
    switch(GET_SYSTEM_NUMBER()) {
	case 1: {
	    if(btn = 1 && !CombineState[2]) {
		return 1;
	    }
	    else if(btn = 2 ){
		return 1
	    }
	    else {
		return 0;
	    }
	}
	case 2: {
	    return 1;
	}
	case 3: {
	    if(btn = 2 && !CombineState[1]) {
		return 1;
	    }
	    else if(btn = 1 ){
		return 1
	    }
	    else {
		return 0;
	    }
	}
    }
}

/////////////////////////////////////////////////////////////
// fnCombineRoomsUiUpdate () :: Update Combine UI..
define_function fnCombineRoomsUiUpdate () {
    
    // Go to correct page for combine state..
    if(fnRoomsCombined()) {
    
	if(CombineState[1] && CombineState[2]) {
	    send_command dvTP,"'PAGE-Combined3'"
	}
	else {
	    switch(GET_SYSTEM_NUMBER()) {
		case 1: {
		    if(CombineState[1] || CrrCombineState[1]) {
			send_command dvTP,"'PAGE-Combined1'"
		    }
		}
		case 2: {
		    if(CombineState[1] ||CrrCombineState[2]) {
			send_command dvTP,"'PAGE-Combined1'"
		    }
		    else {
			send_command dvTP,"'PAGE-Combined2'"
		    }
		}
		case 3: {
		    if(CombineState[2] || CrrCombineState[2]) {
			send_command dvTP,"'PAGE-Combined2'"
		    }
		}
	    }
	}
	send_command dvTP,"'PPON-Combine'"
    }
    else {
	send_command dvTP,"'PAGE-Single'"
	send_command dvTP,"'PPON-Combine'"
    }
    
    // Turn on combine state buttons..
    if(CombineState[1]) {
	on[dvTpCombine,btnCombinePresets[1]]
    }
    else {
	off[dvTpCombine,btnCombinePresets[1]]
    }
    if(CombineState[2]) {
	on[dvTpCombine,btnCombinePresets[2]]
    }
    else {
	off[dvTpCombine,btnCombinePresets[2]]
    }

    // Update the Combine Masking..
    switch(GET_SYSTEM_NUMBER()) {
	case 1: {
	    send_command dvTpCombine,"'^SHO-',itoa(vtRoomBlanks[1]),',0'"
	    
	    if(CombineState[1]) {
		send_command dvTpCombine,"'^SHO-',itoa(vtRoomBlanks[2]),',0'"
	    }
	    else {
		send_command dvTpCombine,"'^SHO-',itoa(vtRoomBlanks[2]),',1'"
	    }
	}
	case 2: {
	    send_command dvTpCombine,"'^SHO-',itoa(vtRoomBlanks[1]),',0'"
	    send_command dvTpCombine,"'^SHO-',itoa(vtRoomBlanks[2]),',0'"
	}
	case 3: {
	    send_command dvTpCombine,"'^SHO-',itoa(vtRoomBlanks[2]),',0'"
	    
	    if(CombineState[2]) {
		send_command dvTpCombine,"'^SHO-',itoa(vtRoomBlanks[1]),',0'"
	    }
	    else {
		send_command dvTpCombine,"'^SHO-',itoa(vtRoomBlanks[1]),',1'"
	    }
	}
    }
    fnSetRoomName ()
}

define_function fnCombinePresetCmd () {

    if(CombineState[1] && CombineState[2]) {
	// Combine Rooms 1,2 and 3..
	fnRecallPreset(4) 
    }
    else if(CombineState[1]) {
	// Combine Rooms 1 and 2..
	fnRecallPreset(1) 
    }
    else if(CombineState[2]) {
	// Combine Rooms 2 and 3..
	fnRecallPreset(2) 
    }
    else {
	// Split Rooms.. 
	fnRecallPreset(3) 
    }
    
    fnCombineRoomsUiUpdate ()
}

/////////////////////////////////////////////////////////////
//                  StartUp                                //
/////////////////////////////////////////////////////////////
DEFINE_START

/////////////////////////////////////////////////////////////
//                  Event's                                //
/////////////////////////////////////////////////////////////
DEFINE_EVENT

/////////////////////////////////////////////////////////////
// Channel Events..
channel_event[vdvSystem,1] {
    on: { 
	// Start Module..
	on[vdvParameterSet,1]
	on[vdvRoomCombine,1]
    }
}

/////////////////////////////////////////////////////////////
// Button Events..
button_Event[dvTpCombine,btnCombinePresets] {
    push: {

	integer btn;
	
	btn = get_last(btnCombinePresets)
	
	if(CombineState[btn] = 0) {
	    // Update Combine Status..
	    CombineState[btn] = 1
	}	
	// Uncombine Rooms..
	else if(CombineState[btn] = 1 && fnCanUncombinePresets(btn)) {
	    // Update Combine Status..
	    CombineState[btn] = 0
	    
	    // Set room contrling back to default room..
	    roomControling = thisSys;
	}
	else {
	    // Rooms need to be uncombined before they can be combined..
	}
	
	fnCombinePresetCmd() 
	fnRoomSelect()
    }	
}

/////////////////////////////////////////////////////////////
// TimeLine Events..

/////////////////////////////////////////////////////////////
//                  MainLine                               //
/////////////////////////////////////////////////////////////
DEFINE_PROGRAM

/////////////////////////////////////////////////////////////
//                  The End                                //
/////////////////////////////////////////////////////////////

