PROGRAM_NAME='ConferenceRoomRouter'
/////////////////////////////////////////////////////////////
//                                                         //
//                  NetLinx System                         //
//             Project: Bose Control Space Solution        //
//                                                         //
/////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////
//                  Define Device                          //
/////////////////////////////////////////////////////////////
DEFINE_DEVICE

/////////////////////////////////////////////////////////////
//                  Debug	                           //
/////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////
//                  Constants                              //
/////////////////////////////////////////////////////////////
DEFINE_CONSTANT

// Volume Control Step..
cCrrStep = 2

/////////////////////////////////////////////////////////////
//                  Structures                             //
/////////////////////////////////////////////////////////////
DEFINE_TYPE


/////////////////////////////////////////////////////////////
//                  Variables                              //
/////////////////////////////////////////////////////////////
DEFINE_VARIABLE

// Store Level Values.
integer crrLevel[3][8]
integer crrMute[3][8]

// Mute Buttons..
integer btnCrrMute[] = { 1 , 2 , 3 , 4 , 5 }

// Mapping To module..
integer crrMuteChans[]	= { 12 , 21 , 22 , 23 , 5 }

// Levels.. 
integer Crrlvl[]	= { 1 , 2 , 3 , 4 , 5 }
integer CrrLvlFb[]	= { 11 , 12 , 13 , 14 , 15 }
integer CrrLvlMap[]	= { 6 , 21 , 22 , 23 , 1 }

// Volume Control Buttons..
integer btnCrrVolUp[]	= { 11 , 12 , 13 , 14 , 15 }
integer btnCrrVolDn[]	= { 21 , 22 , 23 , 24 , 25 }

/////////////////////////////////////////////////////////////
//                  Functions/Calls                        //
/////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////
// fn..
define_function fnUpdateCrrUi() {
    integer chan;
    
    for(chan = 1; chan <= length_array(Crrlvl); chan++) {
	[dvTpCrr,btnCrrMute[chan]] = crrMute[RoomControling][chan]
	send_level dvTpCrr,CrrLvlFb[chan],crrLevel[RoomControling][chan]
    }
}
/////////////////////////////////////////////////////////////
//                  StartUp                                //
/////////////////////////////////////////////////////////////
DEFINE_START

/////////////////////////////////////////////////////////////
//                  Event's                                //
/////////////////////////////////////////////////////////////
DEFINE_EVENT

/////////////////////////////////////////////////////////////
// Channel Events..
channel_event[vdvSystem,1] {
    on: { 
	// Start Module..
	on[vdvCrr,1]
    }
}

// Mute Feedback..
channel_event[vdvCrrRm,crrMuteChans] {
    on: {
	integer chan,room;
    
	room = get_last(vdvCrrRm);
	chan = get_last(crrMuteChans)
	
	if(room = RoomControling) {
	    on[dvTpCrr,btnCrrMute[chan]]
	}
	
	crrMute[room][chan] = 1
    }
    off: {
	integer chan,room;
    
	room = get_last(vdvCrrRm);
	chan = get_last(crrMuteChans)
	
	if(room = RoomControling) {
	    off[dvTpCrr,btnCrrMute[chan]]
	}
	crrMute[room][chan] = 0
    }
}

/////////////////////////////////////////////////////////////
// Level Events..
// Send Level to module..
level_event[dvTpCrr,Crrlvl] {
    integer lvl;
    
    lvl = get_last(Crrlvl);
    if(tpOnline) {
	send_level vdvCrrRm[RoomControling],CrrLvlMap[lvl],level.value
    }
}

// Update Panel Feedback..
level_event[vdvCrrRm,CrrLvlMap] {

    integer lvl,room;
    
    room = get_last(vdvCrrRm);
    lvl = get_last(CrrLvlMap)
    
    if(room = RoomControling) {
	send_level dvTpCrr,CrrLvlFb[lvl],level.value
    }
    
    crrLevel[room][lvl] = level.value
}

/////////////////////////////////////////////////////////////
// Button Events..
// Mute Control..
button_event[dvTpCrr,btnCrrMute] {
    push: {
	integer btn;
    
	btn = get_last(btnCrrMute)
	do_push(vdvCrrRm[RoomControling],crrMuteChans[btn])
    }
}

// Volume Up..
button_event[dvTpCrr,btnCrrVolUp] {
    push: {
	integer lvl
	
	lvl = get_last(btnCrrVolUp)
	
	if(crrLevel[RoomControling][lvl] + cCrrStep <= 255) {
	    send_level vdvCrrRm[RoomControling],CrrLvlMap[lvl],crrLevel[RoomControling][lvl] + cCrrStep
	}
    }
}

// Volume Down..
button_event[dvTpCrr,btnCrrVolDn] {
    push: {
	integer lvl
	
	lvl = get_last(btnCrrVolDn)
	
	if(crrLevel[RoomControling][lvl] - cCrrStep > 0) {
	    send_level vdvCrrRm[RoomControling],CrrLvlMap[lvl],crrLevel[RoomControling][lvl] - cCrrStep
	}
    }
}

/////////////////////////////////////////////////////////////
//                  MainLine                               //
/////////////////////////////////////////////////////////////
DEFINE_PROGRAM

/////////////////////////////////////////////////////////////
//                  The End                                //
/////////////////////////////////////////////////////////////

