PROGRAM_NAME='Conference_Room'
/////////////////////////////////////////////////////////////
//                                                         //
//                  NetLinx System                         //
//             Project: Bose Control Space Solution        //
//                                                         //
/////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////
//                  Define Device                          //
/////////////////////////////////////////////////////////////
DEFINE_DEVICE

// Control Space IP Port..
dvControlSpace = 0:11:0;

// Touch Screen..
dvTP 		= 	10001:1:0;
dvTpMics	=	10001:2:0;
dvTpCrr		=	10001:3:0;
dvTpVoIP	=	10001:4:0;
dvTpPSTN	=	10001:5:0;
dvTpVideoSwt	=	10001:6:0;
dvTpCombine	=	10001:7:0;
dvTpVoIpOut	=	10001:8:0;
dvTpPSTNOut	=	10001:9:0;

// System VDevice..
vdvSystem 	= 33000:1:0

// Module Virtual Devices..
// Room Current System
vdvAmmGs	= 33001:1:0
vdvCrr		= 33002:1:0
vdvVoIP		= 33003:1:0
vdvVoIpOut	= 33004:1:0
vdvPSTN		= 33005:1:0
vdvPSTNOut	= 33006:1:0
vdvVoIPRouter	= 33007:1:0
vdvPSTNRouter	= 33008:1:0
vdvParameterSet = 33009:1:0
vdvRoomCombine	= 33010:1:0

// Room 1
vdvSystem1 	= 33000:1:1
vdvAmmGs1	= 33001:1:1
vdvCrr1		= 33002:1:1
vdvVoIP1	= 33003:1:1
vdvVoIpOut1	= 33004:1:1
vdvPSTN1	= 33005:1:1
vdvPSTNOut1	= 33006:1:1

// Module Virtual Devices..
// Room 2
vdvSystem2 	= 33000:1:2
vdvAmmGs2	= 33001:1:2
vdvCrr2		= 33002:1:2
vdvVoIP2	= 33003:1:2
vdvVoIpOut2	= 33004:1:2
vdvPSTN2	= 33005:1:2
vdvPSTNOut2	= 33006:1:2

// Module Virtual Devices..
// Room 3
vdvSystem3 	= 33000:1:3
vdvAmmGs3	= 33001:1:3
vdvCrr3		= 33002:1:3
vdvVoIP3	= 33003:1:3
vdvVoIpOut3	= 33004:1:3
vdvPSTN3	= 33005:1:3
vdvPSTNOut3	= 33006:1:3


// Module Virtual Devices..
vdvBoseModuleComms1 	= 33101:1:0
vdvBoseModuleComms2 	= 33102:1:0
vdvBoseModuleComms3 	= 33103:1:0
vdvBoseModuleComms4 	= 33104:1:0
vdvBoseModuleComms5 	= 33105:1:0
vdvBoseModuleComms6 	= 33106:1:0
vdvBoseModuleComms7	= 33107:1:0
vdvBoseModuleComms8	= 33108:1:0

/////////////////////////////////////////////////////////////
//                  Debug	                           //
/////////////////////////////////////////////////////////////
dvDebug		=	0:1:0
/////////////////////////////////////////////////////////////
//                  Constants                              //
/////////////////////////////////////////////////////////////
DEFINE_CONSTANT

integer debugMessages = 1;

// Constants to Link Virtual devices together..
integer cAmmGS		= 1;
integer cCrr		= 2;
integer cVoIP		= 3;
integer cVoIpOut	= 4;
integer cPSTN		= 5;
integer cPSTNOut	= 6;
integer cParamSet	= 7;
integer cCombineRoom	= 8;

// Max Phone Book entries
integer MAX_PB_ENTRIES 	= 64
integer MAX_PB_NAME_LEN = 32
integer MAX_PB_NUM_LEN 	= 32

// MAX Rooms
integer MAX_ROOMS 	= 3

// Global Timeline Constants
Long cTL_PB_REFRESH 	= 1
Long cTL_SYSTEM_REFRESH = 2

// Max phone book entries per page
integer cMaxPbEntriesPerPage = 6

char RoomNames[3][32] = { 'ROOM 1' , 'ROOM 2' , 'ROOM 3'}

// These arrays are used to reference devices in other rooms..
dev vdvAmmGsRm[] 	= { vdvAmmGs1	, vdvAmmGs2	, vdvAmmGs3	}
dev vdvCrrRm[]		= { vdvCrr1	, vdvCrr2	, vdvCrr3	}
dev vdvVoiPRm[]		= { vdvVoIP1	, vdvVoIP2	, vdvVoIP3	}
dev vdvPSTNRm[]		= { vdvPSTN1	, vdvPSTN2	, vdvPSTN3	}
dev vdvVoIpOutRm[] 	= { vdvVoIpOut1	, vdvVoIpOut2	, vdvVoIpOut3	}
dev vdvPSTNOutRm[] 	= { vdvPSTNOut1	, vdvPSTNOut2 	, vdvPSTNOut3	}
dev vdvSystemRm[]	= { vdvSystem1	, vdvSystem2	, vdvSystem3	}

// Preset Office
integer cParamOffset  = 2

/////////////////////////////////////////////////////////////
//                  Structures                             //
/////////////////////////////////////////////////////////////
DEFINE_TYPE

struct _pbEntrie {
    char name[MAX_PB_NAME_LEN]
    char number [MAX_PB_NUM_LEN]
}

struct _pb {
    _pbEntrie entrie[MAX_PB_ENTRIES]
    integer totalEntries
}

/////////////////////////////////////////////////////////////
//                  Variables                              //
/////////////////////////////////////////////////////////////
DEFINE_VARIABLE
char controlSpaceIp[] = '192.168.128.203';

integer controlSpacePort = 10055;

// Phone Books..
_pb 	VoIP_pb
_pb 	PSTN_pb

dev csModuleVirtualdev[] =
{
    vdvAmmGs,
    vdvCrr,
    vdvVoIP,
    vdvVoIpOut
}

dev csInterModuleComms[] = 
{
    vdvBoseModuleComms1,
    vdvBoseModuleComms2,
    vdvBoseModuleComms3,
    vdvBoseModuleComms4,
    vdvBoseModuleComms5,
    vdvBoseModuleComms6,
    vdvBoseModuleComms7,
    vdvBoseModuleComms8
}

char csModuleNames[][20] =
{
    '#AMMGS',
    '#CRR',
    '#VoIP',
    '#VoIP Out',
    '#PSTN',
    '#PSTN Out'
}

// Step size
float stepSize		= 2.0

// Contron Space Connection Status..
integer btnCsConnectionStatus = 1

// System Power off button..
integer btnPowerOff = 2

// Room Select Buttons
integer btnRoomSelect[] = { 1 , 2 , 3 }

// Variable Text Channels
integer vtRoomName = 1

// Room Controling Tracker..
integer roomControling

// Control Space Connection State..
integer CombineState[] = { 0 , 0 }
integer CrrCombineState[] = { 0 , 0 }



// This System Number..
integer thisSys = 0

// Room Number to update..
integer updateRoom = 0

// Update Delay Time..
long tlRoomUpdateTimes[] = { 1000 , 1000 , 1000 , 1000 , 1000 , 2000 }

// Paramater refres time..
integer parameterSetUpdateRate = 50

integer tpOnline = 0
/////////////////////////////////////////////////////////////
//                  Debug                                  //
/////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////
// fnDebug - General debug function..
define_function fndebug ( Char Ident[40] , Char message[255] )
{  
    //on/off for debug messages enable.. 
    if(debugMessages)                                               
        {
        //String to send to debug window..
        send_string dvDebug," Ident ,' : ', Message ,' @ ',Time"    
        }
}

/////////////////////////////////////////////////////////////
//                  Functions/Calls                        //
/////////////////////////////////////////////////////////////

define_function fnIpError ( slong eCode )
{
    switch(eCode)
    {
	case 1:  { fnDebug ( 'IP ERROR' , 'invalid server address' ) }
	case 2:  { fnDebug ( 'IP ERROR' , 'invalid server port' ) }
	case 3:  { fnDebug ( 'IP ERROR' , 'invalid value for Protocol' ) }
	case 4:  { fnDebug ( 'IP ERROR' , 'unable to open communication port with server' ) }
	case 6:  { fnDebug ( 'IP ERROR' , 'Connection refused' ) }
	case 7:  { fnDebug ( 'IP ERROR' , 'Connection timed out' ) }
	case 8:  { fnDebug ( 'IP ERROR' , 'Unknown connection error' ) }
	case 9:  { fnDebug ( 'IP ERROR' , 'Already closed' ) }
	case 10: { fnDebug ( 'IP ERROR' , 'Binding error' ) }
	case 11: { fnDebug ( 'IP ERROR' , 'Listening error' ) }
	case 14: { fnDebug ( 'IP ERROR' , 'Local port already used' ) }
	case 15: { fnDebug ( 'IP ERROR' , 'UDP socket already listening' ) }
	case 16: { fnDebug ( 'IP ERROR' , 'Too many open sockets' ) }
    }
}

define_function fnSetRoomName () {
    integer systemNo,i
    char RoomName[64]
    
    if(CombineState[1]) {
	RoomName = "RoomNames[1],' + ',RoomNames[2]"
	
	if (CombineState[2] ) {
	    RoomName = "RoomName,' + ',RoomNames[3]"
	}
    }
    else if (CombineState[2] ) {
	RoomName = "RoomNames[2],' + ',RoomNames[3]"
    }
    if (!CombineState[1] && !CombineState[2]) {
	RoomName = RoomNames[thisSys]
    }
    
    // Set the room name
    send_command dvTP,"'^BMF-',itoa(vtRoomName),',1&2,%T',RoomName"
}

// On Demand Update of system..
define_function fnUpdateRoom (integer room) {
    fnUpdateMicUi()
    fnUpdateCrrUi()
    fnUpdateVoIPUi ()
    fnUpdatePSTNUi ()
}

// Recall Preset..
define_function fnRecallPreset (integer preset) {
    do_push(vdvParameterSet,preset + cParamOffset)
}

/////////////////////////////////////////////////////////////
// fnRoomSelect ()
define_function fnRoomSelect() {
    integer i;

    // Uncombine Channels..
    UNCOMBINE_CHANNELS(vdvSystem,1)
    
    // Connection feedback Channel..
    COMBINE_CHANNELS (vdvSystemRm[roomControling],1,dvTP,btnCsConnectionStatus)
    
    // Update Room Feedback..
    off[dvTpCombine,btnRoomSelect]
    on[dvTpCombine,btnRoomSelect[roomControling]]
    
    // Update Connection Feedback..
    [dvTP,btnCsConnectionStatus] = [vdvSystemRm[roomControling],1] 
}

/////////////////////////////////////////////////////////////
// fnRoomsCombined () :: Returns 1 if rooms are combined..
define_function integer fnRoomsCombined () {
    if(CombineState[1] || CombineState[2] || CrrCombineState[1] || CrrCombineState[2]) {
	return 1
    }
    else {
	return 0
    }
}

/////////////////////////////////////////////////////////////
// Include Files..
#include 'Microphones.axi'
#include 'AddressBook.axi'
#include 'ConferenceRoomRouter.axi'
#include 'VoIP.axi'
#include 'PSTN.axi'
#include 'VideoSwitching.axi'
#include 'CombineViaPresets.axi'
#include 'CombineViaCrr.axi'

/////////////////////////////////////////////////////////////
// Define Solution modules..
DEFINE_MODULE 'csTCPComms' TCPcomms(vdvSystem , dvControlSpace, controlSpaceIp, controlSpacePort, csModuleNames, csInterModuleComms)

// AMM Gain Share Module..
DEFINE_MODULE 'AMMGSModule' AMMGS1( vdvAmmGS, stepSize, csModuleNames[cAmmGS], csInterModuleComms[cAmmGS])

// Conference Room Router Module
DEFINE_MODULE 'CRRModule' CRR1(vdvCRR, stepSize, csModuleNames[cCrr], csInterModuleComms[cCrr])

// VoIP Conferencing Module
DEFINE_MODULE 'VoIPInputModule' VoIP(vdvVoIP, stepSize, csModuleNames[cVoIP], csInterModuleComms[cVoIP])
DEFINE_MODULE 'UiDialer' UiVoIPDialer( vdvVoIPRouter, dvTpVoIP, btnVoIpDialer, btnVoIpStatus)
DEFINE_MODULE 'GainModule' VoIpOut(vdvVoIpOut, stepSize,csModuleNames[cVoIpOut], csInterModuleComms[cVoIpOut])

// VoIP Conferencing Module
DEFINE_MODULE 'PSTNInputModule' PSTN(vdvPSTN, stepSize, csModuleNames[cPSTN], csInterModuleComms[cPSTN])
DEFINE_MODULE 'UiDialer' UiPSTNDialer( vdvPSTNRouter, dvTpPSTN, btnVoIpDialer, btnVoIpStatus)
DEFINE_MODULE 'GainModule' PSTNOut(vdvPSTNOut, stepSize,csModuleNames[cPSTNOut], csInterModuleComms[cPSTNOut])

// Preset Recall Module..
DEFINE_MODULE 'ParameterSetModule' ParameterSet(vdvParameterSet, parameterSetUpdateRate, csInterModuleComms[cParamSet]) 

// Combine Module..
DEFINE_MODULE 'CombineModule' CombineRooms (vdvRoomCombine , csInterModuleComms[cCombineRoom])
/////////////////////////////////////////////////////////////
//                  StartUp                                //
/////////////////////////////////////////////////////////////
DEFINE_START

thisSys = GET_SYSTEM_NUMBER()
/////////////////////////////////////////////////////////////
//                  Event's                                //
/////////////////////////////////////////////////////////////
DEFINE_EVENT
/////////////////////////////////////////////////////////////
// Button Events..
button_event[dvTP,btnPowerOff] {
    push: {
	// Recall power off preset..
	fnRecallPreset(5) 
    }
}

button_event[dvTpCombine,btnRoomSelect] {
    push: {
	integer btn;
	
	roomControling = get_last(btnRoomSelect)
	
	fnRoomSelect()
	fnUpdateRoom (roomControling)
    }
}

/////////////////////////////////////////////////////////////
// Data Events..
data_event[dvTP] {
    online: {
	
	tpOnline = 1
	// Set the room name
	fnSetRoomName ()
	
	if(!roomControling) {
	    roomControling = GET_SYSTEM_NUMBER()
	    fnRoomSelect()
	}
	
	// Refresh the Tp when it comes online..
	if([vdvSystem,1]) {
	    fnUpdateRoom (roomControling)
	}
    }
    offline: {
	tpOnline = 0
    }
}

data_event[dvTpCombine] {
    online: {
	if(RoomControling) {
	    fnRoomSelect()
	}
	    
	// Go to correct page on panel boot..
	if(fnRoomsCombined()) {
	    send_command dvTP,"'PAGE-Combined'"
	}
	else {
	    send_command dvTP,"'PAGE-Single'"
	}
	
	// Update our combine State..
	fnCombineRoomsUiUpdate ()
	fnCrrCombineRoomsUiUpdate ()
    }	
}

/////////////////////////////////////////////////////////////
// Timeline Events..
// On Demand Update of system..
timeline_event[cTL_SYSTEM_REFRESH] {
    if(updateRoom) {
	switch(timeline.sequence) {
	    case 1: {
		fnUpdateMicUi()
	    }	
	    case 2: {
		fnUpdateCrrUi()
	    }
	    case 3: {
		fnUpdateVoIPUi ()
	    }
	    case 4: {
		fnUpdatePSTNUi ()
	    }
	    case 6: {
		send_command dvTP,'PPOF-Please Wait'
	    }
	}
    }
}
/////////////////////////////////////////////////////////////
//                  MainLine                               //
/////////////////////////////////////////////////////////////
DEFINE_PROGRAM

/////////////////////////////////////////////////////////////
//                  The End                                //
/////////////////////////////////////////////////////////////

