PROGRAM_NAME='Microphones'
/////////////////////////////////////////////////////////////
//                                                         //
//                  NetLinx System                         //
//             Project: Bose Control Space Solution        //
//                                                         //
/////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////
//                  Define Device                          //
/////////////////////////////////////////////////////////////
DEFINE_DEVICE

/////////////////////////////////////////////////////////////
//                  Debug	                           //
/////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////
//                  Constants                              //
/////////////////////////////////////////////////////////////
DEFINE_CONSTANT

// Mic Volume Step..
integer cMicStep = 2

/////////////////////////////////////////////////////////////
//                  Structures                             //
/////////////////////////////////////////////////////////////
DEFINE_TYPE

/////////////////////////////////////////////////////////////
//                  Variables                              //
/////////////////////////////////////////////////////////////
DEFINE_VARIABLE

integer mic = 0

// Mic Control levels..
integer micLvls[] 	= { 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 }

// Mic Feedback Levels
integer micFb[]		= { 11 , 12 , 13 , 14 , 15 , 16 , 17 , 18 }

// Mic Mute Buttons..
integer btnMicMute[]	= { 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 }

// Mic Mute Channels on Module..
integer micMuteChan[]	= { 6 , 13 , 20 , 27 , 34 , 41 , 48 , 55 }

// Mic Volume Control..
integer btnMicChanUp[]	= { 11 , 12 , 13 , 14 , 15 , 16 , 17 , 18 }
integer btnMicChanDn[]	= { 21 , 22 , 23 , 24 , 25 , 26 , 27 , 28 }

// Track Mic levels (0-255)..
integer micLevel[3][8]
integer micMutes[3][8]
/////////////////////////////////////////////////////////////
//                  Functions/Calls                        //
/////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////
//                  Functions/Calls                        //
/////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////
// Define Solution modules..
define_function fnUpdateMicUi() {
    integer mic;
    
    for(mic = 1; mic <= length_array(micLvls); mic++) {
	[dvTpMics,btnMicMute[mic]] = micMutes[RoomControling][mic]
	send_level dvTpMics,micFb[mic],micLevel[RoomControling][mic]
    }
}
/////////////////////////////////////////////////////////////
//                  StartUp                                //
/////////////////////////////////////////////////////////////
DEFINE_START

/////////////////////////////////////////////////////////////
//                  Event's                                //
/////////////////////////////////////////////////////////////
DEFINE_EVENT

/////////////////////////////////////////////////////////////
// Channel Events..
channel_event[vdvSystem,1] {
    on: { 
	// Start Module..
	on[vdvAmmGs,1]
    }
}

// Mic Mute Feedback..
channel_event[vdvAmmGsRm,micMuteChan] {
    on: {
	integer chan,room;
    
	room = get_last(vdvAmmGsRm);
	chan = get_last(micMuteChan)
	
	if(room = RoomControling) {
	    on[dvTpMics,btnMicMute[chan]]
	}
	
	micMutes[room][chan] = 1
    }
    off: {
	integer chan,room;
    
	room = get_last(vdvAmmGsRm);
	chan = get_last(micMuteChan);
	
	if(room = RoomControling) {
	    off[dvTpMics,btnMicMute[chan]]
	}
	
	micMutes[room][chan] = 0
    }
}

/////////////////////////////////////////////////////////////
// Level Events..
// Send Level to module..
level_event[dvTpMics,micLvls] {
    integer mic;
    
    mic = get_last(micLvls);
    
    if(tpOnline) {
	send_level vdvAmmGsRm[RoomControling],mic,level.value
    }
}

// Update Panel Feedback..
level_event[vdvAmmGsRm,micLvls] {

    integer mic,room;
    
    room = get_last(vdvAmmGsRm);
    mic = get_last(micLvls)
    
    if(room = RoomControling) {
	send_level dvTpMics,micFb[mic],level.value
    }
    
    micLevel[room][mic] = level.value
}

/////////////////////////////////////////////////////////////
// Button Events..
button_event[dvTpMics,btnMicMute] {
    push: {
	integer btn;
    
	btn = get_last(btnMicMute)
	do_push(vdvAmmGsRm[RoomControling],micMuteChan[btn])
    }
}

button_event[dvTpMics,btnMicChanUp] {
    push: {
	integer mic
	
	mic = get_last(btnMicChanUp)
	
	if(micLevel[RoomControling][mic] + cMicStep <= 255) {
	    send_level vdvAmmGsRm[RoomControling],mic,micLevel[RoomControling][mic] + cMicStep
	}
    }
}


button_event[dvTpMics,btnMicChanDn] {
    push: {
	integer mic
	
	mic = get_last(btnMicChanDn)
	
	if(micLevel[RoomControling][mic] - cMicStep > 0) {
	    send_level vdvAmmGsRm[RoomControling],mic,micLevel[RoomControling][mic] - cMicStep
	}
    }
}

/////////////////////////////////////////////////////////////
//                  MainLine                               //
/////////////////////////////////////////////////////////////
DEFINE_PROGRAM

/////////////////////////////////////////////////////////////
//                  The End                                //
/////////////////////////////////////////////////////////////

