MODULE_NAME='UiDialer' (dev vdvDevice , dev vdvTP , integer dialButtons[19], integer status[8] )

// dialButtons[1] = 1 
// dialButtons[2] = 2
// dialButtons[3] = 3
// dialButtons[4] = 4
// dialButtons[5] = 5
// dialButtons[6] = 6
// dialButtons[7] = 7
// dialButtons[8] = 8
// dialButtons[9] = 9
// dialButtons[10] = 0
// dialButtons[11] = *
// dialButtons[12] = #
// dialButtons[13] = Clear
// dialButtons[14] = Dial
// dialButtons[15] = Answer
// dialButtons[16] = End
// dialButtons[17] = Transfer
// dialButtons[18] = BackSpace
// dialButtons[19] = ReDial

// Status..
// Status[1] = Dial Number
// Status[2] = CallerID
// Status[3] = Status
// Status[4] = Caller Number
// Status[5] = Volume
// Status[6] = AutoAnswer
// Status[7] = Country Code
// Status[8] = Account status


DEFINE_VARIABLE

char VoIpStringToDial[32]
char VoIpStatus[16]
char VoIpCallerID[20]
char VoIpCallerNumber[13]
char VoIpAccountStatus[20]
char VoIpPreviousNumber[32]

FLOAT fBarGraphLow = 0.0
FLOAT fBarGraphHi = 255.0
FLOAT fLevelHigh = 12.0
FLOAT fLevelLow = -60.5


DEFINE_FUNCTION FLOAT Scale (FLOAT Value, FLOAT X1, FLOAT X2, Float Y1, Float Y2)
{
    RETURN ((y2-y1)/(X2-X1))*(Value-X1)+Y1
}

define_function fnUpdateVoIpUI ()
{
    if(length_string(VoIpStringToDial))
    {
	send_command vdvTP,"'^BMF-',itoa(Status[1]),',1&2,%T',VoIpStringToDial"
    }
    else
    {
	send_command vdvTP,"'^BMF-',itoa(Status[1]),',1&2,%TEnter Number'"
    }
        
    if(length_string(VoIpCallerId))
    {
	send_command vdvTP,"'^BMF-',itoa(Status[2]),',1&2,%T',VoIpCallerId"
    }
    else
    {
	send_command vdvTP,"'^BMF-',itoa(Status[2]),',1&2,%TCallerID'"
    }
    
    if(length_string(VoIpStatus))
    {
	send_command vdvTP,"'^BMF-',itoa(Status[3]),',1&2,%T',VoIpStatus"
    }
    else
    {
	send_command vdvTP,"'^BMF-',itoa(Status[3]),',1&2,%TCall Status'"
    }

    if(length_string(VoIpCallerNumber))
    {
	send_command vdvTP,"'^BMF-',itoa(Status[4]),',1&2,%T',VoIpCallerNumber"
    }
    else
    {
	send_command vdvTP,"'^BMF-',itoa(Status[4]),',1&2,%TCallerID'"
    }
    if(length_string(VoIpAccountStatus))
    {
	send_command vdvTP,"'^BMF-',itoa(Status[8]),',1&2,%T',VoIpAccountStatus"
    }
    else
    {
	send_command vdvTP,"'^BMF-',itoa(Status[8]),',1&2,%TAccount Status'"
    }
}

DEFINE_EVENT

data_event[vdvDevice]
{
    string:
    {
	if(find_string(data.text,'STATUS=',1))
	{
	    remove_string(data.text,'STATUS=',1)
	    VoIpStatus = data.text
	    fnUpdateVoIpUI ()
	}
	else if(find_string(data.text,'ID=',1))
	{
	    remove_string(data.text,'ID=',1)
	    VoIpCallerID = data.text
	    fnUpdateVoIpUI ()
	}
	else if(find_string(data.text,'ACCOUNT=',1))
	{
	    remove_string(data.text,'=',1)
	    VoIpAccountStatus = data.text
	    fnUpdateVoIpUI ()
	}
	else if(find_string(data.text,'DIAL-NUMBER=',1))
	{
	    remove_string(data.text,'=',1)
	    VoIpStringToDial = data.text
	    fnUpdateVoIpUI ()
	}
	else if(find_string(data.text,'VERSION?',1)) {
	    send_string data.device,'VERSION=%JANUS_VERSION%'
	}
    }
}

data_event[vdvTP]
{
    ONLINE:
    {
	fnUpdateVoIpUI()
    }
}

level_event[vdvDevice,0]
{
    INTEGER lvl
    lvl = LEVEL.INPUT.LEVEL
    SWITCH(lvl)
    {
	CASE 1:
	{
	    SEND_COMMAND vdvTP,"'^TXT-',ITOA(Status[5]),',1,',FORMAT('%.0f',scale(LEVEL.VALUE,fBarGraphLow,fBarGraphHi,fLevelLow,fLevelHigh))"
	}
	CASE 2:
	{
	    SEND_COMMAND vdvTP,"'^TXT-',ITOA(Status[6]),',1,',ITOA(LEVEL.VALUE)"
	}
	CASE 3:
	{
	    SEND_COMMAND vdvTP,"'^TXT-',ITOA(Status[7]),',1,',ITOA(LEVEL.VALUE)"
	}
    }
}

button_event[vdvTP,dialButtons]
{
    push:
    {
	integer btn;
	
	btn = get_last(dialButtons)
	
	if(btn <= 9)
	{
	    VoIpStringToDial = "VoIpStringToDial,itoa(btn)"
	}
	else
	{
	    switch(btn)
	    {
		case 11:
		{
		    VoIpStringToDial = "VoIpStringToDial,'*'"
		}
		case 10:
		{
		    VoIpStringToDial = "VoIpStringToDial,'0'"
		}
		case 12:
		{
		    VoIpStringToDial = "VoIpStringToDial,'#'"
		}
		case 13:
		{
		    VoIpStringToDial = ''
		}
		case 14:
		{
		    VoIpPreviousNumber = VoIpStringToDial
		    send_command vdvDevice,"'DIAL=',VoIpStringToDial"
		}
		case 15:
		{
		    send_command vdvDevice,"'ANSWER'"
		}
		case 16:
		{
		    send_command vdvDevice,"'HANGUP'"
		}
		case 17:
		{
		    send_command vdvDevice,"'TRANSFER=',VoIpStringToDial"
		}
		case 18:
		{
		    if(LENGTH_STRING(VoIpStringToDial))
		    {
			SET_LENGTH_STRING(VoIpStringToDial, LENGTH_STRING(VoIpStringToDial)-1)
		    }
		}
		case 19:
		{
		    if(length_string(VoIpPreviousNumber)) {
			VoIpStringToDial = VoIpPreviousNumber 
			send_command vdvDevice,"'DIAL=',VoIpStringToDial"
		    }
		}
	    }
	}
	
	// Update our UI..
	fnUpdateVoIpUI ()
    }
}