PROGRAM_NAME='VoIP'
/////////////////////////////////////////////////////////////
//                                                         //
//                  NetLinx System                         //
//             Project: Bose Control Space Solution        //
//                                                         //
/////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////
//                  Define Device                          //
/////////////////////////////////////////////////////////////
DEFINE_DEVICE

/////////////////////////////////////////////////////////////
//                  Debug	                           //
/////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////
//                  Constants                              //
/////////////////////////////////////////////////////////////
DEFINE_CONSTANT

// Number of rings before pickup..
integer cVoIpAaNumberOfRings = 5

// Volume Ramp level..
integer cVoIpOutStep = 2
/////////////////////////////////////////////////////////////
//                  Structures                             //
/////////////////////////////////////////////////////////////
DEFINE_TYPE

/////////////////////////////////////////////////////////////
//                  Variables                              //
/////////////////////////////////////////////////////////////
DEFINE_VARIABLE

VOLATILE INTEGER btnVoIpDialer[] =
{
    1,	// Keypad Button : 1
    2,	// Keypad Button : 2
    3,	// Keypad Button : 3
    4,	// Keypad Button : 4	
    5,	// Keypad Button : 5
    6,	// Keypad Button : 6
    7,	// Keypad Button : 7
    8,	// Keypad Button : 8
    9,	// Keypad Button : 9
    10,	// Keypad Button : 0
    11,	// Keypad Button : *
    12,	// Keypad Button : #
    13,	// Clear
    14, // Dial
    15, // Answer
    16, // End
    29, // Transfer
    30, // Backspace
    17	// Re-Dial
}

VOLATILE INTEGER btnVoIpStatus[] = 
{
    6 , // Number Display
    7 , // Caller ID 
    9 , // Status
    99, // < Caller Number - NOT USED >
    1 , // Volume
    3 , // Auto Answer
    4 , // Country Code
    10  // Account Status
}

// Misc VoIP buttons
integer btnVoIpAutoAnswer = 18
integer btnVoIpPrivacy = 19
integer btnVoIpPhoneBook = 20
integer lvlVoIpIncall = 31

// Auto Answer tracker..
integer VoIpAutoAnswer[3]

// Address book tracker..
integer VoIpAbOffset = 0

// Levels..
integer btnVoIPLvl = 1
integer btnVoIPFbLvl = 11

// Mute Controls..
integer btnVoIPMute = 1
integer VoIPMuteMap = 3

// Level Buttons..
integer btnVoIPLvlUp = 11
integer btnVoIPLvlDn = 21

// Level out tracker..
integer voipOutLevel[3]

// Mute out Tracker..
integer voipOutMute[3]


/////////////////////////////////////////////////////////////
//                  Functions/Calls                        //
/////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////
// Update Auto Answer Feedback..
define_function fnUpdateAutoAnswerUi () {
    if(VoIpAutoAnswer[RoomControling]) {
	on[dvTpVoIP,btnVoIpAutoAnswer]
    }
    else {
	off[dvTpVoIP,btnVoIpAutoAnswer]
    }
}

/////////////////////////////////////////////////////////////
// fnDisplayVoIpAddressBook.. 
define_function fnDisplayVoIpAddressBook () {
    VoIpAbOffset = 0
    fnDisplayVoIpPbEntries(1)
    send_command dvTpVoIP,'PPON-VOIP-PhoneBook'
}

/////////////////////////////////////////////////////////////
// fnDisplayVoIpPbEntries.. 
define_function fnDisplayVoIpPbEntries(integer start) {
    integer i;

    for (i = 0; i <= cMaxPbEntriesPerPage - 1; i++) {
	send_command dvTpVoIP,"'^BMF-',itoa(btnAbEntries[i+ 1]),',1&2,%T',VoIP_pb.entrie[i + start].name"
    }
}

/////////////////////////////////////////////////////////////
// fnUpdateVoIPUi
define_function fnUpdateVoIPUi () {
    fnUpdateAutoAnswerUi ()
    [dvTpVoIpOut,btnVoIPMute] = voipOutMute[RoomControling]
    send_level dvTpVoIpOut,btnVoIPFbLvl,voipOutLevel[RoomControling]
}

/////////////////////////////////////////////////////////////
//                  StartUp                                //
/////////////////////////////////////////////////////////////
DEFINE_START

/////////////////////////////////////////////////////////////
//                  Event's                                //
/////////////////////////////////////////////////////////////
DEFINE_EVENT

/////////////////////////////////////////////////////////////
// Channel Events..
channel_event[vdvSystem,1] {
    on: { 
	// Start Module..
	on[vdvVoIP,1]
	on[vdvVoIpOut,1]
    }
}

/////////////////////////////////////////////////////////////
// Button Events..
button_event[dvTpVoIP,btnVoIpAutoAnswer] {
    push: {

	if(VoIpAutoAnswer[RoomControling]) {
	    // Auto Answer Off
	    send_level vdvVoIPRm[RoomControling],2,0
	}
	else {
	    // Auto Answer On
	    send_level vdvVoIPRm[RoomControling],2,cVoIpAaNumberOfRings
	}
    }
}

button_Event[dvTpVoIP,btnVoIpPhoneBook] {
    push: {
	fnDisplayVoIpAddressBook ()
    }
}

button_event[dvTpVoIP,btnAbArrows] {
    push: {
    	integer btn;
	
	btn = get_last(btnAbArrows)
	
	switch(btn) {
	    // Up Arrow..
	    case 1: {
		if(VoIpAbOffset - cMaxPbEntriesPerPage > 0 && VoIpAbOffset - cMaxPbEntriesPerPage <= VoIP_pb.totalEntries) {
		    VoIpAbOffset = VoIpAbOffset - cMaxPbEntriesPerPage
		}
		else {
		    VoIpAbOffset = 1
		}
	    }
	    
	    // Down Arrow..
	    case 2: {
		if(VoIpAbOffset + cMaxPbEntriesPerPage <= VoIP_pb.totalEntries) {
		    VoIpAbOffset = VoIpAbOffset + cMaxPbEntriesPerPage
		}
	    }
	}
	
	fnDisplayVoIpPbEntries(VoIpAbOffset)
    }
}

button_event[dvTpVoIP,btnAbEntries] {
    push: {
	integer btn;
	
	btn = get_last(btnAbEntries)
	
	send_string vdvVoIPRm[RoomControling],"'DIAL-NUMBER=',VoIP_pb.entrie[VoIpAbOffset + btn].number"
	send_command dvTpVoIP,'PPOF-VOIP-PhoneBook'
    }
}

/////////////////////////////////////////////////////////////
// Level Events..
// Auto answer feedback..
level_event[vdvVoIPRm,2] {
    integer room;
    
    room = get_last(vdvVoIPRm)
    
    VoIpAutoAnswer[room] = level.value
    
    if(room = RoomControling) {
	fnUpdateAutoAnswerUi ()
    }
}

/////////////////////////////////////////////////////////////
// Channel Events..
// Call Active..
channel_event[vdvVoIPRm,21] {
    on:{ 
	integer room;
	
	room = get_last(vdvVoIPRm)
	
	if(room = RoomControling) {
	    send_command dvTpVoIP,"'^SHO-',itoa(lvlVoIpIncall),',0'"
	}
    }
    off: {
    	integer room;
	
	room = get_last(vdvVoIPRm)
	
	if(room = RoomControling) {
	    send_command dvTpVoIP,"'^SHO-',itoa(lvlVoIpIncall),',1'"
	}
    }
}
// Ringing..
channel_event[vdvVoIPRm,22] {
    on:{ 
	integer room;
	
	room = get_last(vdvVoIPRm)
	
	if(room = RoomControling) {
	    send_command dvTpVoIP,'PPON-VOIP-Call'
	}
	
    }
    off: {
	integer room;
	
	room = get_last(vdvVoIPRm)
	
	if(room = RoomControling) {
	    send_command dvTpVoIP,'PPOF-VOIP-Call'
	}
	
    }
}

/////////////////////////////////////////////////////////////
// Data Events..
// The following events pass data between the UIDialer and the VoIP Module..
data_event[vdvVoIPRouter] {
    command: {
	send_command vdvVoIPRm[RoomControling],data.text
    }

}

data_event[vdvVoIPRm] {
    string: {
	integer room;
	
	room = get_last(vdvVoIPRm)
	
	if(room = RoomControling) {
	    send_string vdvVoIPRouter,data.text
	}
    }
}

/////////////////////////////////////////////////////////////
// VoIP Output Control..
/////////////////////////////////////////////////////////////

// Send Level to module..
level_event[dvTpVoIpOut,btnVoIPLvl] {
    if(tpOnline) {
	send_level vdvVoIpOutRm[RoomControling],btnVoIPLvl,level.value
    }
}

// Update Panel Feedback..
level_event[vdvVoIPOutRm,btnVoIPLvl] {

    integer lvl,room;
    
    room = get_last(vdvVoIPOutRm);
    
    if(room = RoomControling) {
	send_level dvTpVoIpOut,btnVoIPFbLvl,level.value
    }
    
    voipOutLevel[room] = level.value
}

button_event[dvTpVoIpOut,btnVoIPMute] {
    push: {
	do_push(vdvVoIPOutRm[RoomControling],VoIPMuteMap)
    }
}

channel_event[vdvVoIPOutRm,VoIPMuteMap] {
    on: {
	integer room;
    
	room = get_last(vdvVoIPOutRm);
	
	if(room = RoomControling) {
	    on[dvTpVoIpOut,btnVoIPMute]
	}
	
	voipOutMute[room] = 1
    }
    off: {
	integer room;
    
	room = get_last(vdvVoIPOutRm);
	
	if(room = RoomControling) {
	    off[dvTpVoIpOut,btnVoIPMute]
	}
	voipOutMute[room] = 0
    }
}

button_event[dvTpVoIpOut,btnVoIPLvlUp] {
    push: {
	if(voipOutLevel[RoomControling] + cVoIpOutStep <= 255) {
	    send_level vdvVoIpOutRm[RoomControling],btnVoIPLvl,voipOutLevel[RoomControling] + cVoIpOutStep
	}
    }
}


button_event[dvTpVoIpOut,btnVoIPLvlDn] {
    push: {
	if(voipOutLevel[RoomControling] - cVoIpOutStep <= 255) {
	    send_level vdvVoIpOutRm[RoomControling],btnVoIPLvl,voipOutLevel[RoomControling] - cVoIpOutStep
	}
    }
}

/////////////////////////////////////////////////////////////
//                  MainLine                               //
/////////////////////////////////////////////////////////////
DEFINE_PROGRAM

/////////////////////////////////////////////////////////////
//                  The End                                //
/////////////////////////////////////////////////////////////

